local MedievalWall = ...

---------------------------------
--| Register Particle Systems |--
---------------------------------
MedievalWall:register({
	DataType = "PARTICLE_SYSTEM",
	Id = "FIRE_PARTICLE_SYSTEM",
	Material = "FIRE_MATERIAL",
	BillboardBehavior = "FACE_CAMERA",
	Duration = 1.5,
	Looping = true,
	Delay = { 0, 0 },
	LifeTime = 1.5,
	StartSpeed = { 0.3, 0.3 },
	StartSize = { 2.5, 2.5 },
	StartRotation = { 0, 0 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = -0.001,
	RateOverTime = 15,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
		Angle = 0.1,
		Radius = 0.0001,
	},
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
		ValueA = { 0.1, 0, 0.1 },
		ValueB = { -0.1, 0, -0.1 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0, Color = { 0.6, 0.6, 0, 1} },
			{ T = 0.1, Color = { 0.4, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.4, 0.4, 0.4, 1 } },
			{ T = 1, Color = { 0.1, 0.1, 0.1, 0.5 } }
		},
		AlphaList = {
			{ T = 0.1, Alpha = 10 },
			{ T = 0.2, Alpha = 90 },
			{ T = 0.3, Alpha = 0 },
			{ T = 0.4, Alpha = 0 },
			{ T = 0.5, Alpha = 90 },
			{ T = 0.6, Alpha = 0 },
			{ T = 0.7, Alpha = 40 },
			{ T = 0.8, Alpha = 20 },
			{ T = 0.9, Alpha = 10 },
			{ T = 1, Alpha = 0 }
		},
	},
	SizeOverLifetime = {
			{ T = 0, Value = 0.1 },
			{ T = 0.5, Value = 0.2 },
			{ T = 1, Value = 0.3 }
	},
	RotationOverLifetime = { -70, 70 },
})

MedievalWall:register({
	DataType = "PARTICLE_SYSTEM",
	Id = "SMOKE_PARTICLE_SYSTEM",
	Material = "SMOKE_MATERIAL",
	BillboardBehavior = "FACE_CAMERA",
	Duration = 5,
	Looping = true,
	Delay = { 0, 0 },
	LifeTime = 4,
	StartSpeed = { 0.3, 0.3 },
	StartSize = { 2.5, 2.5 },
	StartRotation = { 0, 0 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = 0,
	RateOverTime = 2,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
		Angle = 0.1,
		Radius = 0.0001,
	},
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
		ValueA = { 0.05, 0, 0.05 },
		ValueB = { -0.05, 0, -0.05 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0, Color = { 0.6, 0.6, 0, 1} },
			{ T = 0.1, Color = { 0.4, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.4, 0.4, 0.4, 1 } },
			{ T = 1, Color = { 0.1, 0.1, 0.1, 0.5 } }
		},
		AlphaList = {
			{ T = 0.1, Alpha = 0 },
			{ T = 0.2, Alpha = 20 },
			{ T = 0.4, Alpha = 30 },
			{ T = 0.6, Alpha = 40 },
			{ T = 0.7, Alpha = 80 },
			{ T = 0.8, Alpha = 30 },
			{ T = 1, Alpha = 0 }
		},
	},
	SizeOverLifetime = {
			{ T = 0.1, Value = 0.2 },
			{ T = 0.5, Value = 0.3 },
			{ T = 1, Value = 0.3 }
	},
	RotationOverLifetime = { -50, 50 }
})

MedievalWall:register({
	DataType = "PARTICLE_SYSTEM",
	Id = "SMOKE2_PARTICLE_SYSTEM",
	Material = "SMOKE_MATERIAL",
	BillboardBehavior = "FACE_CAMERA",
	Duration = 5,
	Looping = true,
	Delay = { 0, 0 },
	LifeTime = 10,
	StartSpeed = { 0.3, 0.3 },
	StartSize = { 3, 3 },
	StartRotation = { 0, 0 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = 0,
	RateOverTime = 3,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
		Angle = 0.1,
		Radius = 0.0001,
	},
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
		ValueA = { 0.05, 0, 0.05 },
		ValueB = { -0.05, 0, -0.05 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0, Color = { 0.6, 0.4, 0, 1} },
			{ T = 0.1, Color = { 0.4, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.4, 0.4, 0.4, 1 } },
			{ T = 1, Color = { 0.1, 0.1, 0.1, 0.5 } }
		},
		AlphaList = {
			{ T = 0.1, Alpha = 15 },
			{ T = 0.2, Alpha = 20 },
			{ T = 0.4, Alpha = 30 },
			{ T = 0.6, Alpha = 40 },
			{ T = 0.7, Alpha = 50 },
			{ T = 0.8, Alpha = 40 },
			{ T = 0.9, Alpha = 20 },
			{ T = 1, Alpha = 0 }
		},
	},
	SizeOverLifetime = {
			{ T = 0.1, Value = 0.2 },
			{ T = 0.3, Value = 0.3 },
			{ T = 0.7, Value = 0.4 },
			{ T = 1, Value = 0.5 }
	},
	RotationOverLifetime = { -50, 50 }
})

MedievalWall:register({
	DataType = "PARTICLE_SYSTEM",
	Id = "SPARK_PARTICLE_SYSTEM",
	Material = "SPARK_MATERIAL",
	BillboardBehavior = "FACE_CAMERA",
	Duration = 2,
	Looping = true,
	Delay = { 0, 1 },
	LifeTime = 1.7,
	StartSpeed = { 0.005, 0.005 },
	StartSize = { 0.5, 0.5 },
	StartRotation = { 0, 0 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = -0.2,
	RateOverTime = 4,
	RateOverTimeRandom = 6,
	AlignWithVelocity = true,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
		Angle = 2,
		Radius = 0.1
	},
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
		ValueA = { 0.5, -0.1, 0.5 },
		ValueB = { -0.5, -0.1, -0.5 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0, Color = { 0.6, 0.6, 0, 1} },
			{ T = 0.1, Color = { 0.6, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.6, 0.4, 0.4, 1 } },
			{ T = 1, Color = { 0.1, 0.1, 0.1, 1 } }
		},		
		AlphaList = {
			{ T = 0.1, Alpha = 100 },
			{ T = 0.3, Alpha = 100 },
			{ T = 0.5, Alpha = 50 },
			{ T = 0.7, Alpha = 25 },
			{ T = 1, Alpha = 0 }
		},
	},
	SizeOverLifetime = {
			{ T = 0, Value = 0.075 },
			{ T = 0.5, Value = 0.050 },
			{ T = 1, Value = 0.025 }
	},
	RotationOverLifetime = { -50, 50 }
})

MedievalWall:register({
	DataType = "PARTICLE_SYSTEM",
	Id = "TORCH_PARTICLE_SYSTEM",
	Material = "FIRE_MATERIAL",
	BillboardBehavior = "FACE_CAMERA",
	Duration = 3,
	Looping = true,
	Delay = { 0, 0 },
	LifeTime = 1,
	StartSpeed = { 0.3, 0.3 },
	StartSize = { 0.7, 0.7 },
	StartRotation = { 0, 0 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = 0,
	RateOverTime = 12,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
		Angle = 0.1,
		Radius = 0.0001,
	},
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
		ValueA = { 0.05, 0, 0.05 },
		ValueB = { -0.05, 0, -0.05 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0, Color = { 0.6, 0.6, 0, 1} },
			{ T = 0.1, Color = { 0.4, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.4, 0.4, 0.4, 1 } },
			{ T = 1, Color = { 0.1, 0.1, 0.1, 0.5 } }
		},
		AlphaList = {
			{ T = 0.1, Alpha = 0 },
			{ T = 0.3, Alpha = 75 },
			{ T = 0.5, Alpha = 100 },
			{ T = 0.7, Alpha = 50 },
			{ T = 1, Alpha = 0 }
		},
	},
	SizeOverLifetime = {
			{ T = 0, Value = 0.2 },
			{ T = 0.6, Value = 0.3 },
			{ T = 1.2, Value = 0.4 }
	},
	RotationOverLifetime = { -45, 45 },
})

------------------------------------
--| Register Particle Components |--
------------------------------------
MedievalWall:registerPrefabComponent("models/ironfencedark.fbx/Prefab/Deco_Brazier_On_Fire_Part/FireEmitter1", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "FIRE_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = true
})
MedievalWall:registerPrefabComponent("models/ironfencedark.fbx/Prefab/Deco_Brazier_On_Fire_Part/SmokeEmitter1", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "SMOKE_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = true
})
MedievalWall:registerPrefabComponent("models/ironfencedark.fbx/Prefab/Deco_Brazier_On_Fire_Part/SparkEmitter1", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "SPARK_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = true
})
MedievalWall:registerPrefabComponent("models/ironfencedark.fbx/Prefab/Deco_Brazier_On_Fire_Part/SparkEmitter2", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "SPARK_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = true
})
MedievalWall:registerPrefabComponent("models/ironfencedark.fbx/Prefab/Deco_Brazier_On_Part/SmokeEmitter2", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "SMOKE2_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = true
})
MedievalWall:registerPrefabComponent("models/ironfencedark.fbx/Prefab/Deco_Wall_Torch_On_Fire_Part/FireTorchEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "TORCH_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = true
})